package javax.xml.ws.spi;

import java.util.concurrent.Executor;
import javax.xml.ws.handler.HandlerResolver;
import java.net.URL;
import java.util.Iterator;
import javax.xml.bind.JAXBContext;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Service;
import javax.xml.ws.EndpointReference;
import javax.xml.ws.WebServiceFeature;
import javax.xml.namespace.QName;

public abstract class ServiceDelegate
{
    protected ServiceDelegate() {
    }
    
    public abstract <T> T getPort(QName p0, Class<T> p1);
    
    public abstract <T> T getPort(QName p0, Class<T> p1, WebServiceFeature... p2);
    
    public abstract <T> T getPort(EndpointReference p0, Class<T> p1, WebServiceFeature... p2);
    
    public abstract <T> T getPort(Class<T> p0);
    
    public abstract <T> T getPort(Class<T> p0, WebServiceFeature... p1);
    
    public abstract void addPort(QName p0, String p1, String p2);
    
    public abstract <T> Dispatch<T> createDispatch(QName p0, Class<T> p1, Service.Mode p2);
    
    public abstract <T> Dispatch<T> createDispatch(QName p0, Class<T> p1, Service.Mode p2, WebServiceFeature... p3);
    
    public abstract <T> Dispatch<T> createDispatch(EndpointReference p0, Class<T> p1, Service.Mode p2, WebServiceFeature... p3);
    
    public abstract Dispatch<Object> createDispatch(QName p0, JAXBContext p1, Service.Mode p2);
    
    public abstract Dispatch<Object> createDispatch(QName p0, JAXBContext p1, Service.Mode p2, WebServiceFeature... p3);
    
    public abstract Dispatch<Object> createDispatch(EndpointReference p0, JAXBContext p1, Service.Mode p2, WebServiceFeature... p3);
    
    public abstract QName getServiceName();
    
    public abstract Iterator<QName> getPorts();
    
    public abstract URL getWSDLDocumentLocation();
    
    public abstract HandlerResolver getHandlerResolver();
    
    public abstract void setHandlerResolver(HandlerResolver p0);
    
    public abstract Executor getExecutor();
    
    public abstract void setExecutor(Executor p0);
}
